//
//  OCPostRequest.h
//  Webservices
//
//  Created by Manfred Kress on 22.01.10.
//  Copyright 2010 ObjectiveCeeds. All rights reserved.
//

#import <Foundation/Foundation.h>

/*!
    @header OCPostRequest

*/


extern NSString * const kOHTTPPostMethod;

/*!
    @class
    @abstract    Controlles a http POST request
    @discussion  This class handles a very basic http POST 
				request. The intension is, to have a common
				class, that subclasses can override to handle
				webservices based on a POST request.
*/
@interface OCPostRequest : NSObject {

	NSMutableURLRequest *_OCURLRequest;
	NSError				*_OCError;
}
/*!
    @property     
    @abstract   The NSMutableURLRequest wrapped by the object
    @discussion Each instance of OCPostRequest wrappes a NSMutableURLRequest
				to handle the https post. Subclasses, like OCFormPoster can
				access the request to add thyr own propertys
*/
@property (readonly) NSMutableURLRequest *request;

/*!
    @property     
    @abstract   Error occured while posting
    @discussion By default this value is nil. If an error
				occures while posting, you can access it.
*/
@property (readonly) NSError *error;

/*!
    @property     
    @abstract   The URL as string
    @discussion This method wrappes the NSMutableURLRequest's NSURL
				to a convienient string.
*/
@property (retain, readwrite) NSString *URLString;

/*!
	@property     
	@abstract   The posted data
	@discussion This method wrappes the NSMutableURLRequest's setHTTPBody method.
*/
@property (retain, readwrite) NSData *postBody;

/*!
    @method     
    @abstract   And action...
    @discussion After setting up the URL and the posted data
				the rquest is submitted here.
*/
- (NSData *) sendSynchronous;

@end
