//
//  OCSOAPAdd.m
//  Post
//
//  Created by Manfred Kress on 04.07.10.
//  Copyright 2010 ObjectiveCeeds. All rights reserved.
//

#import "OCSOAPAdd.h"


@implementation OCSOAPAdd

@synthesize result = _OCResult;
@synthesize error = _OCError;

- (id) initWithInt: (int)a andInt: (int)b
{
	self = [super init];
	if (self != nil) {
		
		// load stub
		NSString *filePath = [[NSBundle mainBundle] pathForResource: @"request" ofType: @"xml"];
		NSLog(@"%@", filePath);
		
		if (filePath == nil)
		{
			NSLog(@"No such file ...");
			return nil;
		}
		
		NSString *xmlRequest = [[NSString alloc] initWithContentsOfFile: filePath];
		
		if (filePath == nil)
		{
			NSLog(@"Unable to load data ...");
			return nil;
		}	
		
		// replace...
		//NSLog(@"request %@", xmlRequest);
		
		NSString *value1 = [NSString stringWithFormat: @"%d", a];
		NSString *value2 = [NSString stringWithFormat: @"%d", b];
		
		NSString *replace1 = [xmlRequest stringByReplacingOccurrencesOfString: @"###value1@@@" withString: value1];
		NSString *replace2 = [replace1 stringByReplacingOccurrencesOfString: @"###value2@@@" withString: value2];
		
		NSLog(@"request %@", replace2);
		
		OCPostRequest *request = [[OCPostRequest alloc] init];
		[request setPostBody:  [replace2 dataUsingEncoding: NSUTF8StringEncoding]];
		[request setURLString: @"http://localhost/soap/soap/server.php"];
		
		NSData *result = [request sendSynchronous];
		if (result == nil)
		{
			NSLog(@"Panic, strange things goin on");
			return NO;
		}
		
		/*
		NSString *res = [[NSString alloc] initWithData: result encoding: NSUTF8StringEncoding];
		NSLog(@"result %@", res);
		[res release];
		*/
		
		OCXMLParser *parser = [[OCXMLParser alloc] initWithXMLData: result delegate: nil];
		
		OCXMLNode *root = [[parser stack] objectAtIndex: 0];
		//NSLog(@"%@", root);
		OCXMLNode *env = [[root childElements] objectAtIndex: 0];
		//NSLog(@"%@", env);
		OCXMLNode *body = [[env childElements] objectAtIndex: 0];
		//NSLog(@"%@", body);
		OCXMLNode *addResponse = [[body childElements] objectAtIndex:0];
		//NSLog(@"%@", addResponse);
		OCXMLNode *ret = [[addResponse childElements] objectAtIndex: 0];
		//NSLog(@"%@", ret);
		//NSLog(@"payload %@", [ret stringPayload]);
		
		_OCResult = [[ret stringPayload] intValue];
		
		//NSLog(@"attributes %@", [ret attributes]);
		
		[parser release];
	}
	return self;
}

- (id) init
{
	return nil;
}

- (void) dealloc
{
	[self setError: nil];
	[self setResult: 0];
	
	[super dealloc];
}

@end
